﻿package {
	
	import flash.display.Sprite;
	import flash.media.SoundMixer;
	import flash.utils.ByteArray;
	import flash.events.Event;

	public class Visualization extends Sprite {

		public function Visualization() {		
			var ball:Sprite;
			for (var i:int=0; i<256; i++) {
				ball = new BallRed();
				ball.x = i*2;
				addChild(ball);
			}
			for (i=0; i<256; i++) {
				ball = new BallYellow();
				ball.x = i*2;
				addChild(ball);
			}
		
			addEventListener(Event.ENTER_FRAME, onVisualize, false, 0, true);
		}
		
		private function onVisualize(evt:Event):void {
			var bytes:ByteArray = new ByteArray();
			SoundMixer.computeSpectrum(bytes, false, 0);
			
			for (var i:Number = 0; i < 256; i++) {
				getChildAt(i).y = 100 - (bytes.readFloat() * 200);
			}
			for (i = 256; i < 512; i++) {
				getChildAt(i).y = 200 - (bytes.readFloat() * 200);
			}
		}
	}
}