﻿package {

	import flash.display.Sprite;
	import flash.net.URLRequest;
	import flash.media.*;
	import flash.events.*;
	import Visualization;

	public class Main extends Sprite {

		private var _snd:Sound = new Sound();
		private var _channel:SoundChannel = new SoundChannel();
		private var _vis:Visualization;

		public function Main() {
			_snd.addEventListener(IOErrorEvent.IO_ERROR, onIOError, false, 0, true);
			_snd.addEventListener(Event.COMPLETE, onLoadComplete, false, 0, true);
			
			_snd.load(new URLRequest("../audio/gb4.mp3"));
		}
		
		private function onLoadComplete(evt:Event):void {
			removeEventListener(IOErrorEvent.IO_ERROR, onIOError);
			
			_vis = new Visualization();
			_vis.x = _vis.y = 20;
			addChild(_vis);
			_vis.stage.frameRate = 30;
			
			_channel = _snd.play();
		}
		
		private function onIOError(evt:IOErrorEvent):void {
			trace("An error occurred when loading the sound:", evt.text);
		}
	}
}