﻿package {
	
	import flash.display.Sprite;
	import flash.display.Graphics;
	import flash.geom.Point;
	import flash.media.SoundMixer;
	import flash.utils.ByteArray;
	import flash.utils.Timer;
	import flash.events.*;

	public class Visualization extends Sprite {

		private var _bytes:ByteArray = new ByteArray();
		private var _g:Graphics;

		public function Visualization() {
			var canvas:Sprite = new Sprite();
			addChild(canvas);
			_g = canvas.graphics;
		
			addEventListener(Event.ENTER_FRAME, onVisualize, false, 0, true);
		}
		
		private function onVisualize(evt:Event):void {
			SoundMixer.computeSpectrum(_bytes, false, 0);
			_g.clear();
			plotWaveform(0xFF0000,130);
			plotWaveform(0xFFFF00,250);
		}
		
		private function plotWaveform(col:uint, chanBaseline:Number):void {
			_g.lineStyle(0, col);
			_g.beginFill(col, 0.5);
			_g.moveTo(0, chanBaseline);
			for (var i:Number = 0; i < 256; i++) {
				_g.lineTo(i*2, chanBaseline - (_bytes.readFloat() * 200));
			}
			_g.lineTo(i*2, chanBaseline);
			_g.endFill();
		}
	}
}