﻿package {
	
	import flash.display.Sprite;
	import flash.geom.Point;
	import flash.media.SoundMixer;
	import flash.utils.ByteArray;
	import flash.utils.Timer;
	import flash.events.*;

	public class Visualization extends Sprite {

		private var _bytes:ByteArray = new ByteArray();
		private var _canvas:Sprite = new Sprite();

		public function Visualization() {
			addChild(_canvas);
			_canvas.x = 20;
			_canvas.y = 20;
			
			var ball:Sprite;
			for (var i:int=0; i<256; i++) {
				ball = new BallRed();
				ball.x = i*2;
				_canvas.addChild(ball);
			}
			for (i=0; i<256; i++) {
				ball = new BallYellow();
				ball.x = i*2;
				_canvas.addChild(ball);
			}
		
			addEventListener(Event.ENTER_FRAME, onVisualize, false, 0, true);
		}
		
		private function onVisualize(evt:Event):void {
			SoundMixer.computeSpectrum(_bytes, false, 0);
			
			for (var i:Number = 0; i < 256; i++) {
				_canvas.getChildAt(i).y = 130 - (_bytes.readFloat() * 200);
			}
			for (i = 256; i < 512; i++) {
				_canvas.getChildAt(i).y = 230 - (_bytes.readFloat() * 200);
			}
		}
	}
}